/*********************************************************************
 * clsAsyncFileReaderW.cpp
 *     񓯊t@Cobt@NX
 * Author
 *     "ĂƁ" <tategoto@harpy.jp>
 * Version
 *     1.02
 * Updated
 *     2011/10/24
 *********************************************************************/


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

//////////// wb_[CN[h ////////////

#include  "clsAsyncFileReaderW.h"
#include  <iostream>

using namespace  std;

#define  _


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

//////////// Tu[`` ////////////

// WIN32 G[R[hɕϊăbZ[W{bNXŕ\
static void  PrintError(DWORD LastError, LPCWSTR func_name = NULL)
{
	LPVOID  lpMsgBuf;
	FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, NULL, LastError, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR)&lpMsgBuf, 0, NULL);
	if(func_name)
	{
		OutputDebugStringW(func_name);
		OutputDebugStringW(L"(): ");
	}
	OutputDebugStringW((LPCWSTR)lpMsgBuf);
	LocalFree((HLOCAL)lpMsgBuf);
}


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

//////////// cls_AsyncFileReaderW NX ////////////

// RXgN^
cls_AsyncFileReaderW::cls_AsyncFileReaderW(LPCWSTR FileName, DWORD BufSize): hThread(NULL), hEventEnd(NULL), hEventAsync(NULL), hEventRead(NULL), hFile(INVALID_HANDLE_VALUE), ReadBuf(NULL), ReadSize(0), BufSize(BufSize), Processing(false)
{
	// ǂݍ݃obt@̊m
	ReadBuf = HeapAlloc(GetProcessHeap(), NULL, BufSize + 1);
	if(!ReadBuf)
	{
		PrintError(GetLastError(), L"HeapAlloc");
		return;
	}

	// IʒmpCxg̍쐬
	hEventEnd = CreateEvent(NULL, TRUE, FALSE, NULL);
	if(!hEventEnd)
	{
		PrintError(GetLastError(), L"CreateEvent");
		Free();
		return;
	}

	// ǏoopCxg̍쐬
	hEventAsync = CreateEvent(NULL, TRUE, FALSE, NULL);
	if(!hEventAsync)
	{
		PrintError(GetLastError(), L"CreateEvent");
		Free();
		return;
	}

	// o͗pCxg̍쐬Ǝ擾
	hEventRead = CreateEvent(NULL, TRUE, FALSE, NULL);
	if(!hEventRead)
	{
		PrintError(GetLastError(), L"CreateEvent");
		Free();
		return;
	}

	// ǂݍݑΏۃt@C̃I[v
	hFile = CreateFile(FileName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN, NULL);
	if(hFile == INVALID_HANDLE_VALUE)
	{
		PrintError(GetLastError(), L"CreateFile");
		OutputDebugStringW(FileName);
		OutputDebugStringW(L"\r\n");
		Free();
		return;
	}

	// t@Cǂݍ݃Xbh̋N
	DWORD  Dummy;
	hThread = CreateThread(NULL, 0, AsyncReadingThreadProc, this, 0, &Dummy);
	if(!hThread)
	{
		PrintError(GetLastError(), L"CreateThread");
		Free();
		return;
	}

	// t@Cǂݍ݃Xbh̊Jn
	Processing = true;
	SetEvent(hEventAsync);
}


////////////////////////////////////////////////////////////////////////////////

// fXgN^
cls_AsyncFileReaderW::~cls_AsyncFileReaderW()
{
	Free();
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

// RXgN^Ă true
bool   cls_AsyncFileReaderW::IsReady()
{
	if(!hEventEnd || WaitForSingleObject(hEventEnd, 0) == WAIT_OBJECT_0)
		return false;
	return true;
}


////////////////////////////////////////////////////////////////////////////////

// ̃f[^ǂ݁Aǂݍ݃oCgԂ
DWORD  cls_AsyncFileReaderW::Read(LPVOID DestBuf)
{
	HANDLE  Handles[2] = { hEventRead, hEventEnd };
	WaitForMultipleObjects(2, Handles, FALSE, INFINITE);
	ResetEvent(hEventRead);

	CopyMemory(DestBuf, ReadBuf, ReadSize);
	DWORD  RetSize = ReadSize;

	SetEvent(hEventAsync);
	return RetSize;
}


////////////////////////////////////////////////////////////////////////////////

// ǂݍݒ̃t@C̑TCYԂ
LONGLONG  cls_AsyncFileReaderW::FileSize()
{
	LARGE_INTEGER  li = { 0 };
	if(GetFileSizeEx(hFile, &li))
		return li.QuadPart;
	PrintError(GetLastError(), L"GetFileSizeEx");
	return 0;
}


////////////////////////////////////////////////////////////////////////////////

// ȍL郊\[X̉
void  cls_AsyncFileReaderW::Free()
{
	if(hThread)
	{
		Processing = false;
		WaitForSingleObject(hThread, INFINITE);
	//	if(WaitForSingleObject(hThread, 0) == WAIT_TIMEOUT)
	//		TerminateThread(hThread, 0);
		CloseHandle(hThread);
		hThread = NULL;
	}
	if(hEventAsync)
	{
		CloseHandle(hEventAsync);
		hEventAsync = NULL;
	}
	if(hEventRead)
	{
		CloseHandle(hEventRead);
		hEventRead = NULL;
	}
	if(hFile)
	{
		CloseHandle(hFile);
		hFile = INVALID_HANDLE_VALUE;
	}
	if(hEventEnd)
	{
		CloseHandle(hEventEnd);
		hEventEnd = NULL;
	}
	if(ReadBuf)
	{
		HeapFree(GetProcessHeap(), NULL, ReadBuf);
		ReadBuf = NULL;
	}

	BufSize = ReadSize = 0;
}


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

// 񓯊ǂݍ݃[`
DWORD WINAPI  AsyncReadingThreadProc(LPVOID lpParameter)
{
	cls_AsyncFileReaderW  &reader = *(cls_AsyncFileReaderW *)lpParameter;
	for(;_;)
	{
		HANDLE  Handles[2] = { reader.hEventAsync, reader.hEventEnd };
		WaitForMultipleObjects(2, Handles, FALSE, INFINITE);
		if(!reader.Processing)
			return 0;
		ResetEvent(reader.hEventAsync);
		DWORD  ReadSize = 0;
		if(!ReadFile(reader.hFile, reader.ReadBuf, reader.BufSize, &ReadSize, NULL) || !ReadSize)
		{
			reader.ReadSize = 0;
			CloseHandle(reader.hFile);
			reader.hFile = INVALID_HANDLE_VALUE;
			SetEvent(reader.hEventEnd);
			return 0;
		}
		reader.ReadSize = ReadSize;
		SetEvent(reader.hEventRead);
	}
}


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
